VERSION 5.00
Begin VB.Form DTSExmp1 
   Caption         =   "DTS Simple Package"
   ClientHeight    =   2385
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4635
   LinkTopic       =   "Form1"
   ScaleHeight     =   2385
   ScaleWidth      =   4635
   StartUpPosition =   3  'Windows Default
   Begin VB.Label Label3 
      Caption         =   "To use the example, either create an ODBC datasource called SQL7 or edit the code to specify a datasource where the AuthorName table resides."
      Height          =   615
      Left            =   120
      TabIndex        =   2
      Top             =   1560
      Width           =   4335
   End
   Begin VB.Label Label2 
      Caption         =   "You must create the AuthorName table in the pubs sample database before using this example."
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   4335
   End
   Begin VB.Label Label1 
      Caption         =   "This example contains code that executes on the FormLoad event. Use debugging aids to view creation and use of a simple DTS package object."
      Height          =   735
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4335
   End
End
Attribute VB_Name = "DTSExmp1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*********************************************************************
' DTS Simple Package
'
' This program demonstrates how to create a simple DTS Package
' that copies the results of a query against the authors table using
' Visual Basic.  In order to run this program, you must create an
' ODBC DSN for SQL Server 7.0 call SQL7 and make 'PUBS' the default
' database.  You must run the CreateTable.SQL script to create the
' AuthorName table.
'*********************************************************************

Option Explicit
Private Sub Form_Load()
    Dim oPackage As New DTS.Package
    Dim oConnection As DTS.Connection
    Dim oTask As DTS.Task
    Dim oStep As DTS.Step
    Dim oTransform As DTS.Transformation
    Dim oPumpTask As DTS.DataPumpTask
    Dim oProps As DTS.Properties
    Dim iStatus As Boolean
    Dim i As Integer
    Dim strODBCdsn As String
    Dim strUserName As String
    Dim strPassword As String
    
    
    On Error GoTo PackageError:
    '******************************************************************
    '  Define Package Properties
    '******************************************************************
    oPackage.Name = "DTS Simple Package"
    oPackage.Description = "Example of a simple DTS package"
    '******************************************************************
    '  Define The Source Connection
    '******************************************************************
    strODBCdsn = "SQL7"     'Create a DSN called SQL7 or change name
    strUserName = "sa"      'User name assume same source and dest
    strPassword = ""        'with the same Password
    Set oConnection = oPackage.Connections.New
    oConnection.ID = 1
    oConnection.DataSource = strODBCdsn
    oConnection.UserID = strUserName
    oConnection.Password = strPassword
    oPackage.Connections.Add oConnection
    Set oConnection = Nothing
    '******************************************************************
    '  Define The Destination Connection
    '******************************************************************
    Set oConnection = oPackage.Connections.New
    oConnection.ID = 2
    oConnection.DataSource = strODBCdsn
    oConnection.UserID = strUserName
    oConnection.Password = strPassword
    oPackage.Connections.Add oConnection
    Set oConnection = Nothing
    '******************************************************************
    '  Create Pump Task
    '******************************************************************
    Set oTask = oPackage.Tasks.New("DTSDataPumpTask")
    oTask.Name = "Task1"
    Set oPumpTask = oTask.CustomTask
    oPumpTask.SourceConnectionID = 1
    oPumpTask.SourceSQLStatement = "Select au_lname, au_fname from pubs..authors"
    oPumpTask.DestinationConnectionID = 2
    oPumpTask.DestinationObjectName = "AuthorName"
    '******************************************************************
    '  Simple Copy
    '******************************************************************
    Set oTransform = oPumpTask.Transformations.New("DTS.DataPumpTransformCopy")
    oTransform.Name = "Transform"
    oTransform.TransformFlags = DTSTransformFlag_AllowLosslessConversion
    oPumpTask.Transformations.Add oTransform
    oPackage.Tasks.Add oTask
    Set oTask = Nothing
    Set oStep = oPackage.Steps.New
    oStep.Name = "Step1"
    oStep.TaskName = "Task1"
    oPackage.Steps.Add oStep
    Set oStep = Nothing
    '******************************************************************
    '  Execute the Package
    '******************************************************************
    oPackage.Execute
    '******************************************************************
    '  Check for Errors
    '******************************************************************
    iStatus = True
    For i = 1 To oPackage.Steps.Count
        If oPackage.Steps(i).ExecutionResult = DTSStepExecResult_Failure Then
            iStatus = False
            MsgBox oPackage.Steps(i).Name + " in the " + oPackage.Description + " failed."
        End If
    Next i
    If iStatus = True Then
        MsgBox oPackage.Description + " Successful"
    End If
    Set oPackage = Nothing
    Unload Me
Exit Sub
'******************************************************************
'  Package Error Handler
'******************************************************************
PackageError:
For i = 1 To oPackage.Steps.Count
        If oPackage.Steps(i).ExecutionResult = DTSStepExecResult_Failure Then
            iStatus = False
            MsgBox oPackage.Steps(i).Name + " in the " + oPackage.Description + " failed."
        End If
Next i
If iStatus = True Then
    MsgBox oPackage.Description + " Successful"
End If
Unload Me
Exit Sub
End Sub

