VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CreatePivotTable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements DTS.CustomTask
 
Private Description As String
Private TaskName As String
Public strSQL As String
Public strSource As String
Public strTableDestination As String
Public strTableName As String
Public strPageFields As String
Public strRowFields As String
Public strColumnFields As String
Public strPivotFields As String
Public strFileName As String
Public Property Get CustomTask_Description() As String
    CustomTask_Description = Description
End Property
Public Property Let CustomTask_Description(ByVal vNewValue As String)
    Description = vNewValue
End Property
Public Property Get CustomTask_Name() As String
    CustomTask_Name = TaskName
End Property
Public Property Let CustomTask_Name(ByVal vNewValue As String)
    TaskName = vNewValue
End Property
Public Property Get CustomTask_Properties() As DTS.Properties
    'Return Nothing unless you want to do something sophisticated
    'DTS will implement a properties provider around your custom task object
    Set CustomTask_Properties = Nothing
End Property
Public Sub CustomTask_Execute(ByVal pPackage As Object, ByVal pPackageEvents As Object, ByVal pPackageLog As Object, pTaskResult As DTSTaskExecResult)
                             
    Dim oPackage As DTS.Package
    Set oPackage = pPackage
    'Extract info from package here and then *please* release it.
    Set oPackage = Nothing
    'Assume success
    pTaskResult = DTSTaskExecResult_Success
    '*******************************************************************
    ' Declare objects
    '*******************************************************************
    Dim xlApp As Object             ' Excel Application Object
    Dim xlSheet As Excel.Worksheet
    '*******************************************************************
    ' See if Excel is already running
    '*******************************************************************
    Err.Clear
    On Error Resume Next
    Set xlApp = GetObject(, "Excel.Application.8")
    If Err.Number = 429 Then
        '***************************************************************
        ' Excel is NOT running, so create a new instance
        '***************************************************************
        On Error Resume Next
        Set xlApp = CreateObject("Excel.Application.8")
        'Set xlBook = xlApp.Workbooks.Add
        On Error Resume Next
        xlApp.Workbooks.Add
    End If
    
    If Err.Number <> 429 And Err.Number <> 0 Then
        MsgBox "Starting Excel: " & Str$(Err.Number) & Err.Description
    End If
    '*******************************************************************
    ' Make sure Excel is visble
    '*******************************************************************
    xlApp.Visible = True
    '*******************************************************************
    ' Add a new worksheet
    '*******************************************************************
    'On Error GoTo ErrorAddingWorksheet
    On Error Resume Next
    'xlSheet.Add
    Set xlSheet = xlApp.Worksheets.Add
    'xlApp.Worksheets.Add
ErrorAddingWorksheet:
    If (Err.Number) <> 0 Then
        MsgBox "Error adding worksheet: " & Str$(Err.Number) & Err.Description
    End If
    '*******************************************************************
    ' Create the pivot table
    '*******************************************************************
    On Error GoTo ErrorCreatingPivotTable
    xlApp.ActiveSheet.PivotTableWizard SourceType:=xlExternal, SourceData:=Array(strSQL), TableDestination:=strTableDestination, TableName:=strTableName, BackgroundQuery:=False, Connection:=strSource
    xlApp.ActiveSheet.PivotTables(strTableName).AddFields RowFields:=strRowFields, ColumnFields:=strColumnFields
    xlApp.ActiveSheet.PivotTables(strTableName).PivotFields(strPivotFields).Orientation = xlDataField
ErrorCreatingPivotTable:
    If (Err.Number) <> 0 Then
        MsgBox "Error creating pivot table: " & Str$(Err.Number) & Err.Description
    End If
    '*******************************************************************
    ' Auto format the table
    '*******************************************************************
    xlApp.ActiveSheet.PivotTables(strTableName).PivotSelect "", xlDataAndLabel
    xlApp.Selection.AutoFormat Format:=xlRangeAutoFormatClassic3, Number:=True, Font _
        :=True, Alignment:=True, Border:=True, Pattern:=True, Width:=True
    '*******************************************************************
    ' Make the first cell active
    '*******************************************************************
    xlApp.ActiveSheet.Range("A1").Select
    '*******************************************************************
    ' SAve the workbook to the specified file?
    '*******************************************************************
    On Error GoTo ErrorSavingWorksheet
ErrorSavingWorksheet:
    If (Err.Number) <> 0 Then
        MsgBox "error saving worksheet: " & Str$(Err.Number) & Err.Description
    End If
    '*******************************************************************
    ' Leave Excel Running
    '*******************************************************************
    'xlApp.Quit
    Set xlApp = Nothing
    Set xlSheet = Nothing
    GoTo CommandDone
CommandError:
    MsgBox "error", , "error"
    pTaskResult = DTSTaskExecResult_Failure
CommandDone:
End Sub




