VERSION 5.00
Begin VB.Form frmDTSCustomTask 
   Caption         =   "DTSCustomTask"
   ClientHeight    =   3675
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5085
   LinkTopic       =   "Form1"
   ScaleHeight     =   3675
   ScaleWidth      =   5085
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "CreatePivotTable"
      Default         =   -1  'True
      Height          =   495
      Left            =   1440
      TabIndex        =   2
      Top             =   3120
      Width           =   2175
   End
   Begin VB.Label Label3 
      Caption         =   "All sample code is attached to the Click event of the CreatePivotTable command button. Simply click the button to exercise the example code."
      Height          =   735
      Left            =   120
      TabIndex        =   3
      Top             =   2160
      Width           =   4815
   End
   Begin VB.Label Label2 
      Caption         =   "To successfully run the example, you must first create the DTS custom task ActiveX component using the CPTAXDLL.vbp project. Compile the associated project DLL. VisualBasic registers the CreatePivotTable custom task on successful compilation of the dynamic link library."
      Height          =   975
      Left            =   120
      TabIndex        =   1
      Top             =   1080
      Width           =   4815
   End
   Begin VB.Label Label1 
      Caption         =   "This example exercises a DTS custom task ActiveX component. The component uses data from the SQL Server pubs sample database to create a pivot table in Microsoft Excel 97. Microsoft Excel 97 is required for the example."
      Height          =   855
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4815
   End
End
Attribute VB_Name = "frmDTSCustomTask"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()
    '******************************************************************
    ' Set MousePointer to WaitCursor to let the world know we're
    ' working.
    '******************************************************************
    frmDTSCustomTask.MousePointer = 11
    
    Dim oPackage As New DTS.Package
    Dim oTask As DTS.Task
    Dim oStep As DTS.Step
    Dim oProps As DTS.Properties
    Dim oTaskProps As Object
    Dim strTemp As String
    Dim strServer As String
    Dim strDatabase As String
    Dim strUser As String
    Dim strPassword As String
    Dim strConnect As String
    
    Dim iStatus As Boolean
    Dim I As Integer
    On Error GoTo PackageError:
    
    '******************************************************************
    '  Server Database User Password
    '******************************************************************
    strServer = "(local)"
    strDatabase = "pubs"
    strUser = "sa"
    strPassword = ""
    
    '******************************************************************
    '  Define Package Properties
    '******************************************************************
    oPackage.Name = "Pivot Table"
    oPackage.Description = "Create Excel Pivot Table"
                
    '******************************************************************
    '  Create Excel Pivot Table Task
    '******************************************************************
    Set oTask = oPackage.Tasks.New("DTSCreatePivotTable.CreatePivotTable")
    oTask.Name = "Task1"
    Set oTaskProps = oTask.Properties
    oTaskProps("strSQL") = "select stor_id, ord_date, qty from sales order by ord_date"
    strConnect = "ODBC;DRIVER=SQL Server;SERVER=" + strServer + ";UID=" + strUser + ";PWD=" + strPassword + ";APP=DTSPivotTask;WSID=STEWARTM_P2;DATABASE=" + strDatabase
    oTaskProps("strSource") = strConnect
    oTaskProps("strTableDestination") = "R1C1"
    oTaskProps("strTableName") = "PivotTable"
    oTaskProps("strPageFields") = ""
    oTaskProps("strRowFields") = "ord_date"
    oTaskProps("strColumnFields") = "stor_id"
    oTaskProps("strPivotFields") = "qty"
    oTaskProps("strFileName") = "DTSPivotTable.xls"
    oPackage.Tasks.Add oTask
    '******************************************************************
    '  Create A Step
    '******************************************************************
    Set oStep = oPackage.Steps.New
    oStep.Name = "Step1"
    oStep.TaskName = "Task1"
    
    'For custom tasks written in VB, the steps cannot run on a secondary thread.
    oStep.ExecuteInMainThread = True 

    oPackage.Steps.Add oStep
    '******************************************************************
    '  Execute the Package
    '******************************************************************
    oPackage.Execute
    MsgBox oPackage.Description + " Done"
    '******************************************************************
    '  Package Error Handler
    '******************************************************************
PackageError:
    For I = 1 To oPackage.Steps.Count
            If oPackage.Steps(I).ExecutionResult = DTSStepExecResult_Failure Then
                iStatus = False
                MsgBox oPackage.Steps(I).Name + " in the " + oPackage.Description + " failed."
            End If
    Next I
    
    Set oStep = Nothing
    Set oTaskProps = Nothing
    Set oProps = Nothing
    Set oTaskProps = Nothing
    Set oPackage = Nothing
    
    frmDTSCustomTask.MousePointer = 1
    Exit Sub

End Sub
Private Sub Form_Load()
    Left = (Screen.Width - Width) / 2   ' Center form horizontally.
    Top = (Screen.Height - Height) / 2  ' Center form vertically.
End Sub
