Attribute VB_Name = "Module1"
'**********************************************************
'    DTSQry sample program                                *
'                                                         *
'    This program demonstrates how to create a simple     *
'    DTS package using an SQL statement or an ActiveX     *
'    script. The program provides a form that allows the  *
'    user to specify a variety of data sources and data   *
'    destinations.                                        *
'**********************************************************

'**********************************************************
'    Standard module with procedures for working with     *
'    files. Part of the MDI Notepad sample application.   *
'**********************************************************
Option Explicit
Public strsrcODBCdsn As String
Public strsrcUserName As String
Public strsrcPassword As String
Public strdstODBCdsn As String
Public strdstUserName As String
Public strdstPassword As String
Public strQryStatement As String
Public srcSQLFile As String
Public dstSQLFile As String
Public formtype As Boolean
Public strpbstrSource As String
Public strpbstrDescription As String
Public strpbstrHelpFile As String
Public lpHelpContext As Long
Public strpbstrIDOfInterfaceWithError As String
Public lpErrorCode As Long
Public pErrorCode As Long
Public strDTSName As String


Sub FileOpenProc()
    Dim intRetVal
    On Error Resume Next
    Dim strOpenFileName As String
    With frmSQLData
        .CMDialog1.Filename = ""
        .CMDialog1.ShowOpen
    End With
    If Err <> 32755 Then    ' User chose Cancel.
        strOpenFileName = frmSQLData.CMDialog1.Filename
        ' If the file is larger than 65K, it can't
        ' be opened, so cancel the operation.
        If FileLen(strOpenFileName) > 65000 Then
            MsgBox "The file is too large to open."
            Exit Sub
        End If
        
        OpenFile (strOpenFileName)
        strDTSName = strOpenFileName
    End If
End Sub

Function GetFileName(Filename As Variant)
    ' Display a Save As dialog box and return a filename.
    ' If the user chooses Cancel, return an empty string.
    On Error Resume Next
    With frmSQLData
        .CMDialog1.Filename = Filename
        .CMDialog1.ShowSave
    End With
    If Err <> 32755 Then    ' User chose Cancel.
        GetFileName = frmSQLData.CMDialog1.Filename
    Else
        GetFileName = ""
    End If
End Function

Sub OpenFile(Filename)
    Dim fIndex As Integer
    Dim tmpType As String
    Dim szNextLine$, szLines$, tmpSRC$, tmpDST$
    
    On Error Resume Next
    ' Open the selected file.
    Open Filename For Input As #1
    If Err Then
        MsgBox "Can't open file: " + Filename
        Exit Sub
    End If
    ' Change the mouse pointer to an hourglass.
    Screen.MousePointer = 11
    Line Input #1, tmpType
    ' Type is transformation and a VBScript
    If tmpType = "Transformation" Then
        Line Input #1, tmpSRC
        Line Input #1, tmpDST
        With frmSQLData
            .txtSrcTable.Text = tmpSRC
            .SQLDstTable.Text = tmpDST
            .txtSrcTable.Visible = True
            .lblTrans.Visible = True
            .OptionSQL.Value = False
            .OptionScript.Value = True
        End With
    Else
    ' Type is a SQL Statement
        Line Input #1, tmpDST
        With frmSQLData
            .SQLDstTable.Text = tmpDST
            .txtSrcTable.Visible = False
            .lblTrans.Visible = False
            .OptionScript.Value = False
            .OptionSQL.Value = True
        End With
    End If
    
    ' Change the form's caption and display the new text.
    Do While Not EOF(1)
        Line Input #1, szNextLine
        szLines = szLines & szNextLine & vbCrLf
    Loop
    With frmSQLData
        .Caption = "DTS Example - " & Filename & "; Source - " & strsrcODBCdsn & "; Destination - " & strdstODBCdsn & ";"  ' Update the Form Title
        .SQLText.Text = szLines
    End With
    Close #1
    ' Reset the mouse pointer.
    Screen.MousePointer = 0
End Sub

Sub SaveFileAs(Filename)
    On Error Resume Next
    Dim strContents As String

    ' Open the file.
    Open Filename For Output As #1
    ' Place the contents of the notepad into a variable.
    strContents = frmSQLData.SQLText.Text
    ' Display the hourglass mouse pointer.
    Screen.MousePointer = 11
    ' Write the variable contents to a saved file.
    If frmSQLData.OptionScript = True Then
        Print #1, "Transformation"
        Print #1, Trim(frmSQLData.txtSrcTable)
    Else
        Print #1, "SQLScript"
    End If
    Print #1, Trim(frmSQLData.SQLDstTable)
    
    Print #1, strContents
    Close #1
    ' Reset the mouse pointer.
    Screen.MousePointer = 0
    ' Set the form's caption.
    If Err Then
        MsgBox Error, 48, App.Title
    Else
        With frmSQLData
            .Caption = "DTS Example - " & Filename & "; Source - " & strsrcODBCdsn & "; Destination - " & strdstODBCdsn & ";"  ' Update the Form Title
        End With
    End If
End Sub
Public Sub MainDTSScriptRoutine()

'******************************************************************************
'  This routine creates a DTS Package with one step which has source and
'  destination connection using any provider. If dest is a DTSRowQueue, then
'  external OLEDB data source such as ADO can get the data
'  from a DTS Package
'******************************************************************************
Dim oPackage As New DTS.Package
Dim oConnection As DTS.Connection
Dim oTask As DTS.Task
Dim oStep As DTS.Step
Dim oTransform As DTS.Transformation
Dim oPumpTask As DTS.DataPumpTask
Dim oTaskProps As DTS.Properties
Dim oColumn As DTS.Column
Dim szScripts$
Dim szPersistFile As String
Dim iStatus As Boolean
Dim i As Integer
Dim szFilePath As String

    
On Error GoTo errorHandler:
    '******************************************************************
    '  Define Package Properties
    '******************************************************************
    If strDTSName = "" Then
          strDTSName = "Untitled DTS Package"
    End If
    With oPackage
        .Name = "DTS Package"
        .Description = strDTSName
        .WriteCompletionStatusToNTEventLog = True
    End With
    '******************************************************************
    '  Define The Source Connection
    '******************************************************************
    Set oConnection = oPackage.Connections.New
    With oConnection
        .ID = 1
        .DataSource = strsrcODBCdsn
        .UserID = strsrcUserName
        .Password = strsrcPassword
    End With
    oPackage.Connections.Add oConnection
    Set oConnection = Nothing
    
    '******************************************************************
    '  Define The Destination Connection
    '******************************************************************
    Set oConnection = oPackage.Connections.New
    With oConnection
        .ID = 2
        .DataSource = strdstODBCdsn
        .UserID = strdstUserName
        .Password = strdstPassword
    End With
    oPackage.Connections.Add oConnection
    Set oConnection = Nothing
   
    '******************************************************************
    '  Create Pump Task
    '******************************************************************
    Set oTask = oPackage.Tasks.New("DTSDataPumpTask")
    With oTask
        .Name = "Task1"
    End With
    Set oPumpTask = oTask.CustomTask
    With oPumpTask
        .SourceConnectionID = 1
        .SourceObjectName = srcSQLFile     'specify source table
        .DestinationConnectionID = 2
        .DestinationObjectName = dstSQLFile
        .ExceptionFileName = "c:\temp\dts.log"
    End With

    oPackage.Tasks.Add oTask
    Set oTask = Nothing
     
    '********************************************************************
    '  Create a DTS Step and associated a task with it
    '  Step's property IsPackageDSORowset is set to true to enable
    '  it to expose its rowset to external source
    '********************************************************************
    Set oStep = oPackage.Steps.New
    oStep.Name = "Step1"
    oStep.TaskName = "Task1"
    'oStep.IsPackageDSORowset = True    'this setting is only required to setup a package rowset
                                        'if this is set to true for a transform, the step will fail
    oPackage.Steps.Add oStep
    Set oStep = Nothing


    '*******************************************************************
    '  Specify a Transformation using VB Script
    '*******************************************************************
    'Set oTransform = oPumpTask.Transformations.New("DTS.DataPumpTransformCopy")
    Set oTransform = oPumpTask.Transformations.New("DTS.DataPumpTransformScript")   'setup scripting Transform
    oTransform.Name = "AxScriptXform"

    '*******************************************************************
    '  Setup required transform script properties
    '*******************************************************************:
    Set oTaskProps = oTransform.TransformServerProperties
    oTaskProps("Text") = strQryStatement
    oTaskProps("FunctionEntry") = "Transform"
    oTaskProps("Language") = "VBScript"

    oPumpTask.Transformations.Add oTransform           'add transformation to the datapump task
       
   ' Set oColumn = Nothing
    Set oTaskProps = Nothing
    Set oPumpTask = Nothing
    Set oTransform = Nothing
    
           
    '******************************************************************
    ' Execute the package
    '******************************************************************
    oPackage.Execute
    '******************************************************************
    '  Check for Errors
    '******************************************************************
    iStatus = True
    For i = 1 To oPackage.Steps.Count
        If oPackage.Steps(i).ExecutionResult = DTSStepExecResult_Failure Then
            With oPackage.Steps(i)
                .GetExecutionErrorInfo (lpErrorCode)
            End With
            iStatus = False
            With frmSQLData.StatusBar1
                .SimpleText = oPackage.Steps(i).Name + " in the " + oPackage.Description + " failed."  ' Update the status bar
            End With
        End If
    Next i
    If iStatus = True Then
        With frmSQLData.StatusBar1
            .SimpleText = oPackage.Description + " Successful"   ' Update the status bar
            oPackage.WriteCompletionStatusToNTEventLog = True
        End With
    End If
    Set oPackage = Nothing
    'Put out the finish time
    With frmSQLData.lblFinish
        .Enabled = True
        .Visible = True
    End With
    With frmSQLData.lblFinishTime
        .Caption = Format(Now, "Long Time")
    End With
Exit Sub

'******************************************************************
'  Package Error Handler
'******************************************************************
errorHandler:
For i = 1 To oPackage.Steps.Count
        If oPackage.Steps(i).ExecutionResult = DTSStepExecResult_Failure Then
           oPackage.Steps(i).GetExecutionErrorInfo (lpErrorCode)
            iStatus = False
            With frmSQLData.StatusBar1
                .SimpleText = oPackage.Steps(i).Name + " in the " + oPackage.Description + " failed."  ' Update the status bar
            End With
        End If
Next i
If iStatus = True Then
    With frmSQLData.StatusBar1
            .SimpleText = oPackage.Description + " Successful"   ' Update the status bar
    End With
End If
    'Put out the finish time
    With frmSQLData.lblFinish
        .Enabled = True
        .Visible = True
    End With
    With frmSQLData.lblFinishTime
        .Caption = Format(Now, "Long Time")
    End With
Exit Sub

End Sub
Public Sub MainDTSSQLRoutine()
    Dim oPackage As New DTS.Package
    Dim oConnection As DTS.Connection
    Dim oOLEProperty As DTS.OleDBProperty
    Dim oTask As DTS.Task
    Dim oStep As DTS.Step
    Dim oTransform As DTS.Transformation
    Dim oPumpTask As DTS.DataPumpTask
    Dim oProps As DTS.Properties
    Dim iStatus As Boolean
    Dim i As Integer
    
    On Error GoTo PackageError:
    
    '******************************************************************
    '  Define Package Properties
    '******************************************************************
    If strDTSName = "" Then
          strDTSName = "Untitled DTS Package"
    End If
    With oPackage
        .Name = "DTS Package"
        .Description = strDTSName
        .WriteCompletionStatusToNTEventLog = True
    End With
    '******************************************************************
    '  Define The Source Connection
    '******************************************************************
    Set oConnection = oPackage.Connections.New
    'With oOLEProperty
    '    .Value = "SQLOLEDB"
    'End With
    With oConnection
        .ID = 1
       ' .DataSource = "Provider=MSDASQL;Data Source=LocalServer"
        .DataSource = strsrcODBCdsn
        .UserID = strsrcUserName
        .Password = strsrcPassword
    End With
    oPackage.Connections.Add oConnection
    Set oConnection = Nothing
    '******************************************************************
    '  Define The Destination Connection
    '******************************************************************
    Set oConnection = oPackage.Connections.New
    With oConnection
        .ID = 2
        .DataSource = strdstODBCdsn
        .UserID = strdstUserName
        .Password = strdstPassword
    End With
    oPackage.Connections.Add oConnection
    Set oConnection = Nothing
    '******************************************************************
    '  Create Pump Task
    '******************************************************************
    Set oTask = oPackage.Tasks.New("DTSDataPumpTask")
    With oTask
        .Name = "Task1"
    End With
    Set oPumpTask = oTask.CustomTask
    With oPumpTask
        .SourceConnectionID = 1
        .SourceSQLStatement = strQryStatement
        .DestinationConnectionID = 2
        .DestinationObjectName = dstSQLFile
        .ExceptionFileName = "c:\temp\dts.log"
    End With
    '******************************************************************
    '  Simple Copy
    '******************************************************************
    Set oTransform = oPumpTask.Transformations.New("DTS.DataPumpTransformCopy")
    With oTransform
        .Name = "Transform"
        .TransformFlags = DTSTransformFlag_AllowLosslessConversion
    End With
    oPumpTask.Transformations.Add oTransform
    oPackage.Tasks.Add oTask
    Set oTask = Nothing
    Set oStep = oPackage.Steps.New
    oStep.Name = "Step1"
    oStep.TaskName = "Task1"
    oPackage.Steps.Add oStep
    Set oStep = Nothing
    '******************************************************************
    '  Execute the Package
    '******************************************************************
    oPackage.Execute
    '******************************************************************
    '  Check for Errors
    '******************************************************************
    iStatus = True
    For i = 1 To oPackage.Steps.Count
        If oPackage.Steps(i).ExecutionResult = DTSStepExecResult_Failure Then
            With oPackage.Steps(i)
                .GetExecutionErrorInfo (lpErrorCode)
            End With
            iStatus = False
            With frmSQLData.StatusBar1
                .SimpleText = oPackage.Steps(i).Name + " in the " + oPackage.Description + " failed."  ' Update the status bar
            End With
        End If
    Next i
    If iStatus = True Then
        With frmSQLData.StatusBar1
            .SimpleText = oPackage.Description + " Successful"   ' Update the status bar
            oPackage.WriteCompletionStatusToNTEventLog = True
        End With
    End If
    Set oPackage = Nothing
    'Put out the finish time
    With frmSQLData.lblFinish
        .Enabled = True
        .Visible = True
    End With
    With frmSQLData.lblFinishTime
        .Caption = Format(Now, "Long Time")
    End With
Exit Sub
'******************************************************************
'  Package Error Handler
'******************************************************************
PackageError:
For i = 1 To oPackage.Steps.Count
        If oPackage.Steps(i).ExecutionResult = DTSStepExecResult_Failure Then
           oPackage.Steps(i).GetExecutionErrorInfo (lpErrorCode)
            iStatus = False
            With frmSQLData.StatusBar1
                .SimpleText = oPackage.Steps(i).Name + " in the " + oPackage.Description + " failed."  ' Update the status bar
            End With
        End If
Next i
If iStatus = True Then
    With frmSQLData.StatusBar1
            .SimpleText = oPackage.Description + " Successful"   ' Update the status bar
    End With
End If
    'Put out the finish time
    With frmSQLData.lblFinish
        .Enabled = True
        .Visible = True
    End With
    With frmSQLData.lblFinishTime
        .Caption = Format(Now, "Long Time")
    End With
Exit Sub

End Sub
