// dtstask.cpp : Implementation of DLL Exports.


// Note: Proxy/Stub Information
//		To build a separate proxy/stub DLL, 
//		run nmake -f dtstaskps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include "initguid.h"
#include "dtspkg.h"
#include "dtstask.h"

#include "dtstask_i.c"
#include "Task.h"
#include <comcat.h>        // COMponent category manager


HRESULT RegisterTask(CLSID clsid, DWORD dwIconIndex, long resid_task_descr);

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
	OBJECT_ENTRY(CLSID_DTSSampleTask, CTask)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		_Module.Init(ObjectMap, hInstance);
		DisableThreadLibraryCalls(hInstance);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
		_Module.Term();
	return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
	return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
	HRESULT hr;
	// registers object, typelib and all interfaces in typelib
	if (SUCCEEDED(hr = _Module.RegisterServer(TRUE)))
	{
		//Do this for each task in this dll
		hr = RegisterTask(CLSID_DTSSampleTask, IDI_DTSSAMPLETASK_ICON - IDI_FIRSTICON, IDS_DTSSAMPLETASK_DESC);
	}
	return hr;
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
	_Module.UnregisterServer();
	return S_OK;
}

STDAPI RegisterCLSIDInCategory(REFCLSID clsid, CATID catid)
{
   // Register your component categories information.
   ICatRegister* pcr = NULL ;
   HRESULT hr = S_OK ;
   hr = CoCreateInstance(CLSID_StdComponentCategoriesMgr, NULL, CLSCTX_INPROC_SERVER, IID_ICatRegister, (void**)&pcr);
   if (SUCCEEDED(hr))
      {
      // Register this category as being "implemented" by the class.
      CATID rgcatid[1] ;
      rgcatid[0] = catid;
      hr = pcr->RegisterClassImplCategories(clsid, 1, rgcatid);
      }

   if (pcr != NULL)
      pcr->Release();

   return hr;
}

STDAPI UnRegisterCLSIDInCategory(REFCLSID clsid, CATID catid)
{
   ICatRegister* pcr = NULL ;
   HRESULT hr = S_OK ;
   hr = CoCreateInstance(CLSID_StdComponentCategoriesMgr, NULL, CLSCTX_INPROC_SERVER, IID_ICatRegister, (void**)&pcr);
   if (SUCCEEDED(hr))
      {
      // Unregister this category as being "implemented" by the class.
      CATID rgcatid[1] ;
      rgcatid[0] = catid;
      hr = pcr->UnRegisterClassImplCategories(clsid, 1, rgcatid);
      }

   if (pcr != NULL)
      pcr->Release();

   return hr;
}

//Task icons stuff
static const TCHAR cszIconFile[] = TEXT("DTSIconFile");
static const TCHAR cszIconIndex[] = TEXT("DTSIconIndex");
static const TCHAR cszTaskDescription[] = TEXT("DTSTaskDescription");

//Registers a task.
HRESULT RegisterTask(CLSID clsid, DWORD dwIconIndex, long resid_task_descr)
{
	USES_CONVERSION;

	HRESULT hr = E_FAIL;
	TCHAR	pszPath[_MAX_PATH];
	TCHAR szTmp[MAX_PATH];
	LPOLESTR strCLSID;
	LPTSTR szCLSID;
	HKEY hkey;
	TCHAR task_descr_str[MAX_PATH];

	GetModuleFileName(_Module.GetModuleInstance(), pszPath, _MAX_PATH);

	if (FAILED(hr = RegisterCLSIDInCategory(clsid, CATID_DTSCustomTask)))
		return hr;

	StringFromCLSID(clsid, &strCLSID);
	szCLSID = W2A(strCLSID);

	wsprintf(szTmp, TEXT("CLSID\\%s"), szCLSID);

	LoadString(_Module.GetModuleInstance(), resid_task_descr, task_descr_str, MAX_PATH);

	if (ERROR_SUCCESS == RegCreateKey(HKEY_CLASSES_ROOT, szTmp, &hkey))
	{
		RegSetValueEx(hkey, cszIconFile, 0, REG_SZ, (const byte *)pszPath, (_tcslen(pszPath) + 1) * sizeof(TCHAR));
		RegSetValueEx(hkey, cszIconIndex, 0, REG_DWORD, (const byte *)&dwIconIndex, sizeof(dwIconIndex));
		
		//Add the description
		RegSetValueEx(hkey, cszTaskDescription, 0, REG_SZ, (const byte *)task_descr_str, (_tcslen(task_descr_str) + 1) * sizeof(TCHAR));

		RegCloseKey(hkey);
	}
	else
		goto RetErr;

	hr = NOERROR;

RetErr:
	CoTaskMemFree(strCLSID);
	return hr;
}
