// Task.h : Declaration of the CTask

#ifndef __TASK_H_
#define __TASK_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CTask
class ATL_NO_VTABLE CTask : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CTask, &CLSID_DTSSampleTask>,
	public IDispatchImpl<IDTSSampleTask, &IID_IDTSSampleTask, &LIBID_DTSTASKLib>
{
public:
	CTask()
	{
		m_lSuccessReturnCode = 0;
		m_lTimeout = 0;
		m_bTerminateProcessAfterTimeout = VARIANT_FALSE;
		m_bFailPackageOnTimeout = VARIANT_TRUE;
		m_bstrName = SysAllocString(L"");
		m_bstrDescription = SysAllocString(L"");
		m_bstrCommandLine = SysAllocString(L"");;
	}
	~CTask()
	{
		if (m_bstrName) SysFreeString(m_bstrName);
		if (m_bstrDescription) SysFreeString(m_bstrDescription);
		if (m_bstrCommandLine) SysFreeString(m_bstrCommandLine);
	}


DECLARE_REGISTRY_RESOURCEID(IDR_TASK)

BEGIN_COM_MAP(CTask)
	COM_INTERFACE_ENTRY(IDTSSampleTask)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY2(IDTSCustomTask, IDTSSampleTask)
END_COM_MAP()

// IDTSSampleTask
public:
    STDMETHOD(get_Properties)( 
            /* [retval][out] */ IDispatch  **pRetVal);
        
    STDMETHOD(get_Name)( 
            /* [retval][out] */ BSTR  *pRetVal);
        
    STDMETHOD(put_Name)( 
            /* [in] */ BSTR NewValue);
        
    STDMETHOD(get_Description)( 
            /* [retval][out] */ BSTR  *pRetVal);
        
    STDMETHOD(put_Description)( 
            /* [in] */ BSTR NewValue);
        
    STDMETHOD(Execute)( 
            /* [in] */ IDispatch  *pPackage,
            /* [in] */ IDispatch  *pPackageEvents,
            /* [in] */ IDispatch  *pPackageLog,
            /* [out][in] */ LONG  *pTaskResult);
        
    STDMETHOD(get_ProcessCommandLine)( 
            /* [retval][out] */ BSTR  *pRetVal);
        
    STDMETHOD(put_ProcessCommandLine)( 
            /* [in] */ BSTR NewValue);
        
    STDMETHOD(get_SuccessReturnCode)( 
            /* [retval][out] */ LONG  *pRetVal);
        
    STDMETHOD(put_SuccessReturnCode)( 
            /* [in] */ LONG NewValue);
        
    STDMETHOD(get_Timeout)( 
            /* [retval][out] */ LONG  *pRetVal);
        
    STDMETHOD(put_Timeout)( 
            /* [in] */ LONG NewValue);
        
    STDMETHOD(get_TerminateProcessAfterTimeout)( 
            /* [retval][out] */ VARIANT_BOOL  *pRetVal);
        
    STDMETHOD(put_TerminateProcessAfterTimeout)( 
            /* [in] */ VARIANT_BOOL NewValue);
        
    STDMETHOD(get_FailPackageOnTimeout)( 
            /* [retval][out] */ VARIANT_BOOL  *pRetVal);
        
    STDMETHOD(put_FailPackageOnTimeout)( 
            /* [in] */ VARIANT_BOOL NewValue);

private:
	BSTR m_bstrName, m_bstrDescription, m_bstrCommandLine;
	LONG	m_lTimeout, m_lSuccessReturnCode;
	VARIANT_BOOL m_bTerminateProcessAfterTimeout, m_bFailPackageOnTimeout;

};

#endif //__TASK_H_
