// BCPDlg.h : header file
//
// This file is part of Microsoft SQL Server online documentation.
// Copyright (C) 1992-1997 Microsoft Corporation. All rights reserved.
//
// This source code is an intended supplement to the Microsoft SQL
// Server online references and related electronic documentation.
#include "sql.h"
#include "sqlext.h"

/////////////////////////////////////////////////////////////////////////////
// CBCPDlg dialog
/////////////////////////////////////////////////////////////////////////////
class CBCPDlg : public CDialog
{
// Construction
public:
	CBCPDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CBCPDlg)
	enum { IDD = IDD_BCP_DIALOG };
	CStatic	m_staticPath;
	CStatic	m_staticProgress;
	CButton	m_grpFiles;
	CStatic	m_staticDSN;
	CButton	m_grpConnect;
	CProgressCtrl	m_progress;
	CEdit	m_editPath;
	CComboBox	m_comboDSN;
	CButton	m_btnGo;
	CButton	m_btnDisconnect;
	CButton	m_btnConnect;
	CButton	m_btnBrowse;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBCPDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CBCPDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnBrowsePath();
	afx_msg void OnClose();
	afx_msg void OnConnect();
	afx_msg void OnDisconnect();
	afx_msg void OnGo();
	afx_msg void OnChangeEditPath();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
    void SetConnectedButtons();
    void SetReadyButtons();
    void SetGoButtons(BOOL bEnabled);

    void DisplayErrors(SQLSMALLINT eHandleType, SQLHANDLE hodbc);

    SQLRETURN ScriptRun();
    SQLRETURN BCPData();
    BOOL bTableHasIdentity(LPCTSTR szTableName);

public:
    SQLHENV     m_henv;
    SQLHDBC     m_hdbc;
    SQLHSTMT    m_hstmt;

private:
    BOOL        m_bConnected;
    BOOL        m_bCmdFileExists;

    PTSTR       m_szArgs;
    PTSTR       m_szPath;

};
