// GetData.h
//
// This file is part of Microsoft SQL Server online documentation.
// Copyright (C) 1992-1997 Microsoft Corporation. All rights reserved.
//
// This source code is an intended supplement to the Microsoft SQL
// Server online references and related electronic documentation.
#ifndef __GETDATA_H__
#define __GETDATA_H__

#include "sql.h"

#define ALLOCBLOCK      512

typedef struct tagDATA_AT_EXEC
    {
    PBYTE       pData;
    SQLINTEGER  cbData;
    UINT        cbBuffer;
    } DATA_AT_EXEC;
typedef DATA_AT_EXEC* PDATA_AT_EXEC;

PSTR FieldData(PSTR pin, PSTR pout, UINT cboutMax, UINT* pcbout);
PSTR GetBinaryData(PSTR pDataIn, PBYTE pout, UINT cboutMax, UINT* pcbout);
PSTR GetCharData(PSTR pin, PSTR pout, UINT cboutMax, UINT* pcbout);
PSTR GetWCharData(PSTR pin, WCHAR* pout, UINT cboutMax, UINT* pcbout);
BOOL GetColNamesFromData(PSTR pDataIn, UINT* pnDataCols,
        PTSTR** ppColNames);
PSTR GetDateData(PSTR pin, SQL_TIMESTAMP_STRUCT* pts, UINT* pcbout);
PSTR GetIntegerData(PSTR pin, int* pi, UINT* pcbout);
PSTR GetLongBinaryData(PSTR pin, PDATA_AT_EXEC pDataAtExec);
PSTR GetLongCharData(PSTR pin, PDATA_AT_EXEC pDataAtExec);
PSTR GetNumericData(PSTR pin, PSTR pout, UINT cboutMax, UINT* pcbout);

#endif // __GETDATA_H__
