// LoadDataDlg.h : header file
//
// This file is part of Microsoft SQL Server online documentation.
// Copyright (C) 1992-1997 Microsoft Corporation. All rights reserved.
//
// This source code is an intended supplement to the Microsoft SQL
// Server online references and related electronic documentation.
#include "sql.h"
#include "sqlext.h"

#include "GetData.h"

/////////////////////////////////////////////////////////////////////////////
// CLoadDataDlg dialog
/////////////////////////////////////////////////////////////////////////////
class CLoadDataDlg : public CDialog
    {
// Construction
public:
	CLoadDataDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CLoadDataDlg)
	enum { IDD = IDD_LOADDATA_DIALOG };
	CButton	m_grpConnect;
	CStatic	m_staticPath;
	CButton	m_grpFiles;
	CEdit	m_editPath;
	CButton	m_btnClose;
	CButton	m_btnBrowse;
	CButton	m_btnGo;
	CButton	m_btnDisconnect;
	CButton	m_btnConnect;
	CStatic	m_staticDSN;
	CStatic	m_staticProgress;
	CProgressCtrl	m_progress;
	CComboBox	m_comboDSN;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLoadDataDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON       m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CLoadDataDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnClose();
	afx_msg void OnConnect();
	afx_msg void OnDisconnect();
	afx_msg void OnGo();
	afx_msg void OnBrowsePath();
	afx_msg void OnChangeEditPath();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
    SQLRETURN LoadData();
    SQLRETURN GetColAttributes(LPCTSTR szTableName, UINT nCols,
                PTSTR* ppColNames, CObList& ColList);
    BOOL      bTableHasIdentity(CObList& ColList, UINT nCols);
    BOOL      bTableHasLongData(CObList& ColList, UINT nCols);
    SQLRETURN ExecDirectCommand(CString& strCommand);
    void      CalcArraySize(CObList& Columns, UINT nCols, BOOL bHasLongData,
                UINT* aBindOffsets, UINT* aIndOffsets,
                PDATA_AT_EXEC* aDataAtExecs, UINT* pcbParamRow);
    SQLRETURN BindParameters(UINT nCols, CObList& Columns,
                UINT* aBindOffsets, BYTE* pValues, UINT* aIndOffsets,
                BOOL bBindToChar);
    PSTR FillDataArray(CObList& Columns, UINT nCols, UINT nParamRows,
                UINT cbParamRow, PSTR pdata, PBYTE pValues,
                UINT* aBindOffsets, UINT* aIndOffsets, UINT* pnParamsInSet);
    PSTR GetDataRow(CObList& Columns, UINT nCols,  PSTR pdata, PBYTE pValues,
                PDATA_AT_EXEC* aDataAtExecs, UINT* aBindOffsets,
                UINT* aIndOffsets);

    SQLRETURN ScriptRun();

    void      SetConnectedButtons();
    void      SetGoButtons(BOOL bEnabled);
    void      SetReadyButtons();
    void      DisplayErrors(SQLSMALLINT eHandleType, SQLHANDLE hodbc);

public:
// Public so that the application can set and free these on
//  instance initialization and free
    SQLHENV     m_henv;

private:
    BOOL        m_bConnected;
    BOOL        m_bCmdFileExists;
    SQLHDBC     m_hdbc;
    SQLHSTMT    m_hstmt;
    PTSTR       m_szPath;
    PTSTR       m_szArgs;
    };
