// MFCPViewFast.h : interface of the CMFCPViewSlow class
//
// This file is part of Microsoft SQL Server online documentation.
// Copyright (C) 1992-1997 Microsoft Corporation. All rights reserved.
//
// This source code is an intended supplement to the Microsoft SQL
// Server online references and related electronic documentation.

/////////////////////////////////////////////////////////////////////////////
//{{AFX_INCLUDES()
#include "msflexgr.h"
//}}AFX_INCLUDES

#include "FOSet.h"
#include "FODet.h"

class CMFCPCust;

class CMFCPViewFast : public CRecordView
{
protected:
	CMFCPViewFast();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CMFCPViewFast)

// Form Data
public:
	//{{AFX_DATA(CMFCPViewFast)
	enum { IDD = IDD_MFCPERF_FORM };
	CStatic	m_staticToSee;
	CEdit	m_editCountry;
	CEdit	m_editCompany;
	CStatic	m_staticClick;
	CMFCPCust* m_pSet;
	CMSFlexGrid	m_gridDetails;
	CMSFlexGrid	m_gridOrders;
	//}}AFX_DATA

// Attributes
public:
	CMFCPDocFast* GetDocument();
    CFastOrdersSet*     m_pOrders;
    CFastOrdersDetail*  m_pOrdersDetail;

private:
    BOOL                m_bInFill;

// Operations
public:
	CMFCPCust* GetRecordset();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMFCPViewFast)
	public:
	virtual CRecordset* OnGetRecordset();
	virtual BOOL OnMove(UINT nIDMoveCommand);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CMFCPViewFast();

private:
    void GetOrders();
    void GetDetails();

#ifdef _DEBUG
public:
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	// Generated message map functions
	//{{AFX_MSG(CMFCPViewFast)
	afx_msg void OnRowColChangeOrders();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MFCPViewFast.cpp
inline CMFCPDocFast* CMFCPViewFast::GetDocument()
   { return (CMFCPDocFast*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
