// MFCPViewSlow.h : interface of the CMFCPViewSlow class
//
// This file is part of Microsoft SQL Server online documentation.
// Copyright (C) 1992-1997 Microsoft Corporation. All rights reserved.
//
// This source code is an intended supplement to the Microsoft SQL
// Server online references and related electronic documentation.

/////////////////////////////////////////////////////////////////////////////
//{{AFX_INCLUDES()
#include "msflexgr.h"
//}}AFX_INCLUDES

#include "SOSet.h"
#include "SODet.h"

class CMFCPCust;

class CMFCPViewSlow : public CRecordView
{
protected: // create from serialization only
	CMFCPViewSlow();
	DECLARE_DYNCREATE(CMFCPViewSlow)

public:
	//{{AFX_DATA(CMFCPViewSlow)
	enum { IDD = IDD_MFCPERF_FORM };
	CStatic	m_staticClick;
	CStatic	m_staticToSee;
	CEdit	m_editCountry;
	CEdit	m_editCompany;
	CMFCPCust* m_pSet;
	CMSFlexGrid	m_gridDetails;
	CMSFlexGrid	m_gridOrders;
	//}}AFX_DATA

// Attributes
public:
	CMFCPDocSlow* GetDocument();
    CSlowOrdersSet*     m_pOrders;
    CSlowOrdersDetail*  m_pOrdersDetail;

private:
    BOOL                m_bInFill;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMFCPViewSlow)
	public:
	virtual CRecordset* OnGetRecordset();
	virtual BOOL OnMove(UINT nIDMoveCommand);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMFCPViewSlow();

private:
    void GetOrders();
    void GetDetails();

#ifdef _DEBUG
public:
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CMFCPViewSlow)
	afx_msg void OnRowColChangeOrders();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MFCPViewSlow.cpp
inline CMFCPDocSlow* CMFCPViewSlow::GetDocument()
   { return (CMFCPDocSlow*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
