// Globals.cpp
//
// This file is a part of the Microsoft SQL Server on-line documentation.
// Copyright (C) 1992-1997 Microsoft Corporation. All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft SQL Server on-line references and related electronic
// documentation provided with SQL Server.
#include "stdafx.h"
#include "resource.h"

#include "Globals.h"
#include "ODBCErr.h"

void DisplayErrors
    (
    SQLSMALLINT eHandleType,
    SQLHANDLE hodbc
    )
    {
    CODBCErrList*   plistErrors;
    CString         strAllErrors;
    CString         strError;
    UINT            nErr;

    plistErrors = new CODBCErrList(eHandleType, hodbc);
    if (plistErrors->GetReturnCode() == INVALID_OBJECT)
        {
        AfxMessageBox(IDS_INVALID_HANDLE_AT_ERROR);
        delete plistErrors;
        return;
        }

    plistErrors->FormatHeader(strAllErrors);
    for (nErr = 0; nErr < plistErrors->GetCount(); nErr++)
        {
        plistErrors->FormatErr(strError, nErr + 1);
        strAllErrors += _T("\n\n");
        strAllErrors += strError;
        }

    AfxMessageBox(strAllErrors);

    delete plistErrors;
    }
