// LoginDlg.cpp : implementation file
//
// This file is part of Microsoft SQL Server online documentation.
// Copyright (C) 1992-1997 Microsoft Corporation. All rights reserved.
//
// This source code is an intended supplement to the Microsoft SQL
// Server online references and related electronic documentation.
#include "stdafx.h"
#include "Tran.h"
#include "LoginDlg.h"

#include "SQL.h"
#include "SQLExt.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLoginDlg dialog
CLoginDlg::CLoginDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLoginDlg::IDD, pParent)
    {
	//{{AFX_DATA_INIT(CLoginDlg)
	m_bIntegrated = FALSE;
	m_strPWD = _T("");
	m_strUID = _T("");
	//}}AFX_DATA_INIT
    }

void CLoginDlg::DoDataExchange(CDataExchange* pDX)
    {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoginDlg)
	DDX_Control(pDX, IDC_CHECK_INTEGRATED, m_chkIntegrated);
	DDX_Control(pDX, IDC_STATIC_UID, m_staticUID);
	DDX_Control(pDX, IDC_STATIC_UDATA, m_grpUData);
	DDX_Control(pDX, IDC_STATIC_PWD, m_staticPWD);
	DDX_Control(pDX, IDC_EDIT_UID, m_editUID);
	DDX_Control(pDX, IDC_EDIT_PWD, m_editPWD);
	DDX_Control(pDX, IDC_COMBO_DSN, m_comboDSN);
	DDX_Check(pDX, IDC_CHECK_INTEGRATED, m_bIntegrated);
	DDX_Text(pDX, IDC_EDIT_PWD, m_strPWD);
	DDV_MaxChars(pDX, m_strPWD, 32);
	DDX_Text(pDX, IDC_EDIT_UID, m_strUID);
	DDV_MaxChars(pDX, m_strUID, 32);
	//}}AFX_DATA_MAP
    }

BEGIN_MESSAGE_MAP(CLoginDlg, CDialog)
	//{{AFX_MSG_MAP(CLoginDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_DSN, OnSelchangeComboDsn)
	ON_BN_CLICKED(IDC_CHECK_INTEGRATED, OnCheckIntegrated)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoginDlg message handlers
BOOL CLoginDlg::OnInitDialog() 
    {
	CDialog::OnInitDialog();
	
	// Load the data source combo with available SQL Server datasources
    TCHAR       acDSN[SQL_MAX_DSN_LENGTH + 1];
    SQLSMALLINT cbDSN;
    TCHAR       acDesc[SQL_MAX_OPTION_STRING_LENGTH + 1];
    SQLSMALLINT cbDesc;
    SQLRETURN   sRet;
    SQLHENV     hEnv;

    if (SQLAllocEnv(&hEnv) == SQL_ERROR)
        {
        return (TRUE);
        }

    sRet = SQLDataSources(hEnv, SQL_FETCH_FIRST_USER, 
        (SQLTCHAR*) acDSN, SQL_MAX_DSN_LENGTH + 1, &cbDSN,
        (SQLTCHAR*) acDesc, SQL_MAX_OPTION_STRING_LENGTH + 1, &cbDesc);
    while (SQL_SUCCEEDED(sRet))
        {
        if (_tcsstr(acDesc, _T("SQL Server")) != NULL)
            {
            m_comboDSN.AddString(acDSN);
            }
        sRet = SQLDataSources(hEnv, SQL_FETCH_NEXT,
            (SQLTCHAR*) acDSN, SQL_MAX_DSN_LENGTH + 1, &cbDSN,
            (SQLTCHAR*) acDesc, SQL_MAX_OPTION_STRING_LENGTH + 1, &cbDesc);
        }

    // Set the selection for the data source combobox.
    m_comboDSN.SetCurSel(0);
    OnSelchangeComboDsn();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
    }

void CLoginDlg::OnSelchangeComboDsn() 
    {
    // Update our DSN name for the user.
    m_comboDSN.GetLBText(m_comboDSN.GetCurSel(), m_strDSN);
    }

void CLoginDlg::OnCheckIntegrated() 
    {
    if (m_chkIntegrated.GetCheck())
        {
        m_grpUData.EnableWindow(FALSE);
        m_staticUID.EnableWindow(FALSE);
        m_editUID.EnableWindow(FALSE);
        m_staticPWD.EnableWindow(FALSE);
        m_editPWD.EnableWindow(FALSE);

        m_editUID.SetWindowText(_T(""));
        m_editPWD.SetWindowText(_T(""));
        }
    else
        {
        m_grpUData.EnableWindow(TRUE);
        m_staticUID.EnableWindow(TRUE);
        m_editUID.EnableWindow(TRUE);
        m_staticPWD.EnableWindow(TRUE);
        m_editPWD.EnableWindow(TRUE);
        }
	}

