// Pages.cpp : implementation file
//
// This file is part of Microsoft SQL Server online documentation.
// Copyright (C) 1992-1997 Microsoft Corporation. All rights reserved.
//
// This source code is an intended supplement to the Microsoft SQL
// Server online references and related electronic documentation.
#include "stdafx.h"
#include "Tran.h"

#include "Pages.h"
#include "TranView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCustomerPage property page
IMPLEMENT_DYNCREATE(CCustomerPage, CPropertyPage)

CCustomerPage::CCustomerPage() : CPropertyPage(CCustomerPage::IDD)
    {
	//{{AFX_DATA_INIT(CCustomerPage)
	//}}AFX_DATA_INIT
    }

CCustomerPage::~CCustomerPage()
    {
    }

void CCustomerPage::DoDataExchange(CDataExchange* pDX)
    {
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCustomerPage)
	DDX_Control(pDX, IDC_LIST_HISTORY, m_listctrlHistory);
	DDX_Control(pDX, IDC_EDIT_BALANCE, m_editBalance);
	DDX_Control(pDX, IDC_COMBO_CUSTOMER, m_comboCustomers);
	//}}AFX_DATA_MAP
    }

BEGIN_MESSAGE_MAP(CCustomerPage, CPropertyPage)
	//{{AFX_MSG_MAP(CCustomerPage)
	ON_CBN_SELCHANGE(IDC_COMBO_CUSTOMER, OnSelchangeCustomer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomerPage message handlers
void CCustomerPage::OnSelchangeCustomer() 
    {
    m_pview->ChangeCustomer();
    }

/////////////////////////////////////////////////////////////////////////////
// CCheckingPage property page
IMPLEMENT_DYNCREATE(CCheckingPage, CPropertyPage)

CCheckingPage::CCheckingPage() : CPropertyPage(CCheckingPage::IDD)
    {
	//{{AFX_DATA_INIT(CCheckingPage)
	//}}AFX_DATA_INIT
    }

CCheckingPage::~CCheckingPage()
    {
    }

void CCheckingPage::DoDataExchange(CDataExchange* pDX)
    {
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCheckingPage)
	DDX_Control(pDX, IDC_LIST_HISTORY, m_listctrlHistory);
	DDX_Control(pDX, IDC_EDIT_BALANCE, m_editBalance);
	DDX_Control(pDX, IDC_BTN_WITHDRAW, m_btnWithdraw);
	DDX_Control(pDX, IDC_BTN_DEPOSIT, m_btnDeposit);
	//}}AFX_DATA_MAP
    }


BEGIN_MESSAGE_MAP(CCheckingPage, CPropertyPage)
	//{{AFX_MSG_MAP(CCheckingPage)
	ON_BN_CLICKED(IDC_BTN_DEPOSIT, OnBtnDeposit)
	ON_BN_CLICKED(IDC_BTN_WITHDRAW, OnBtnWithdraw)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCheckingPage message handlers
BOOL CCheckingPage::OnSetActive() 
    {
    m_pview->CheckingActive();

	return CPropertyPage::OnSetActive();
    }

void CCheckingPage::OnBtnDeposit() 
    {
    m_pview->CheckingDeposit();
    }

void CCheckingPage::OnBtnWithdraw() 
    {
    m_pview->CheckingWithdrawal();
    }

/////////////////////////////////////////////////////////////////////////////
// CSavingsPage property page
IMPLEMENT_DYNCREATE(CSavingsPage, CPropertyPage)

CSavingsPage::CSavingsPage() : CPropertyPage(CSavingsPage::IDD)
    {
	//{{AFX_DATA_INIT(CSavingsPage)
	//}}AFX_DATA_INIT
    }

CSavingsPage::~CSavingsPage()
    {
    }

void CSavingsPage::DoDataExchange(CDataExchange* pDX)
    {
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSavingsPage)
	DDX_Control(pDX, IDC_LIST_HISTORY, m_listctrlHistory);
	DDX_Control(pDX, IDC_EDIT_BALANCE, m_editBalance);
	DDX_Control(pDX, IDC_BTN_WITHDRAW, m_btnWithdraw);
	DDX_Control(pDX, IDC_BTN_DEPOSIT, m_btnDeposit);
	//}}AFX_DATA_MAP
    }

BEGIN_MESSAGE_MAP(CSavingsPage, CPropertyPage)
	//{{AFX_MSG_MAP(CSavingsPage)
	ON_BN_CLICKED(IDC_BTN_DEPOSIT, OnBtnDeposit)
	ON_BN_CLICKED(IDC_BTN_WITHDRAW, OnBtnWithdraw)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSavingsPage message handlers
BOOL CSavingsPage::OnSetActive() 
    {
    m_pview->SavingsActive();

	return CPropertyPage::OnSetActive();
    }

void CSavingsPage::OnBtnDeposit() 
    {
    m_pview->SavingsDeposit();
    }

void CSavingsPage::OnBtnWithdraw() 
    {
    m_pview->SavingsWithdrawal();
    }
