VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "comctl32.ocx"
Begin VB.Form ReplSampForm 
   Caption         =   "SQL Replication Sample  "
   ClientHeight    =   3120
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3120
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin ComctlLib.ProgressBar ProgressBar 
      Height          =   375
      Left            =   360
      TabIndex        =   2
      Top             =   2520
      Width           =   3855
      _ExtentX        =   6800
      _ExtentY        =   661
      _Version        =   327682
      Appearance      =   1
   End
   Begin VB.CommandButton MergePublication 
      Caption         =   "Update Merge Subscription Tables"
      Height          =   615
      Left            =   360
      TabIndex        =   1
      Top             =   1200
      Width           =   3855
   End
   Begin VB.CommandButton TransPublication 
      Caption         =   "Update Transactional Subscription Tables"
      Height          =   615
      Left            =   360
      TabIndex        =   0
      Top             =   240
      Width           =   3855
   End
   Begin VB.Label ProgressLabel 
      Alignment       =   2  'Center
      Height          =   375
      Left            =   360
      TabIndex        =   3
      Top             =   2040
      Width           =   3855
   End
End
Attribute VB_Name = "ReplSampForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private WithEvents SQLDistribution As SQLDistribution
Attribute SQLDistribution.VB_VarHelpID = -1
Private WithEvents SQLMerge As SQLMerge
Attribute SQLMerge.VB_VarHelpID = -1

Private Sub Form_Load()
    Set SQLDistribution = New SQLDistribution
    Set SQLMerge = New SQLMerge
    
    On Error GoTo Failure
    
    'Load Transactional Subscription Properties
    SQLDistribution.Publisher = Environ("COMPUTERNAME")
    SQLDistribution.PublisherSecurityMode = NT_AUTHENTICATION
    SQLDistribution.PublisherDatabase = "pubs"
    SQLDistribution.Publication = "SampleTransactionalPublication"
    SQLDistribution.Subscriber = Environ("COMPUTERNAME")
    SQLDistribution.SubscriberSecurityMode = NT_AUTHENTICATION
    SQLDistribution.SubscriberDatabase = "pubs_replica"
    SQLDistribution.SubscriptionType = PULL
                    
    'Load Merge Subscription Properties
    SQLMerge.Publisher = Environ("COMPUTERNAME")
    SQLMerge.PublisherSecurityMode = NT_AUTHENTICATION
    SQLMerge.PublisherDatabase = "pubs"
    SQLMerge.Publication = "SampleMergePublication"
    SQLMerge.Subscriber = Environ("COMPUTERNAME")
    SQLMerge.SubscriberSecurityMode = NT_AUTHENTICATION
    SQLMerge.SubscriberDatabase = "pubs_replica"
    SQLMerge.SubscriptionType = PULL
       
    Exit Sub
    
Failure:
    PrintErrors SQLDistribution
End Sub

Private Sub MergePublication_Click()
    On Error GoTo Failure
    
    Dim replerr As SQLReplError
    
    ProgressBar.Value = 0
    ProgressLabel.Caption = "Starting Merge Replication."
    ProgressLabel.Refresh
    MergePublication.Enabled = False
    
    'Initialize
    SQLMerge.Initialize
    
    'Run
    SQLMerge.Run
    
    'Terminate
    SQLMerge.Terminate
         
    'Reset objects
    ProgressBar.Value = 0
    MergePublication.Enabled = True
    
    Exit Sub
        
Failure:
    
    For Each replerr In SQLMerge.ErrorRecords
        MsgBox replerr.Description, vbCritical, "SQL Replication Sample Failure"
    Next replerr
    
    ProgressLabel.Caption = ""
    ProgressBar.Value = 0
    MergePublication.Enabled = True
End Sub

Private Function SQLDistribution_Status(ByVal Message As String, ByVal Percent As Long) As STATUS_RETURN_CODE
    'Update progress information
    ProgressBar.Value = Percent
    ProgressLabel.Caption = Message
    
    'Allow other events
    DoEvents
    
    'Setting the return code to CANCEL will cause the control to cancel operation
    SQLDistribution_Status = SUCCESS
    
End Function
Private Sub PrintErrors(c As Object)
    If Err.Number <> 0 Then
        MsgBox Err.Description, vbCritical, "SQL Replication Sample Failure"
    End If
    
End Sub
Private Function SQLMerge_Status(ByVal Message As String, ByVal Percent As Long) As STATUS_RETURN_CODE
    'Update progress information
    ProgressBar.Value = Percent
    ProgressLabel.Caption = Message
    
    'Allow other events
    DoEvents
    
    SQLMerge_Status = SUCCESS
    
End Function

Private Sub TransPublication_Click()
    On Error GoTo Failure
    
    Dim replerr As SQLReplError
    
    ProgressBar.Value = 0
    ProgressLabel.Caption = "Starting Transactional Replication."
    ProgressLabel.Refresh
    TransPublication.Enabled = False
    
    'Initialize
    SQLDistribution.Initialize
    
    'Run
    SQLDistribution.Run
    
    'Terminate
    SQLDistribution.Terminate
    
    'Reset objects
    TransPublication.Enabled = True
    
    Exit Sub
        
Failure:
    For Each replerr In SQLDistribution.ErrorRecords
        MsgBox replerr.Description, vbCritical, "SQL Replication Sample Failure"
    Next replerr
    ProgressLabel.Caption = ""
    ProgressBar.Value = 0
    TransPublication.Enabled = True
End Sub
