/******************************************************************************
* Microsoft SQLServer
*
* Microsoft Confidential.  Copyright 1993-1994 Microsoft Corporation.
*
* Component: Sample Custom Conflict Resolver
*
* File: resolver.h
*
******************************************************************************/

#ifndef _RESOLVER_H_
#define _RESOLVER_H_

#include "sqlres.h"

/* Implementation of ICustomResolver */
class CSampleCustomResolver: public ICustomResolver
	{
public:
	CSampleCustomResolver();
	~CSampleCustomResolver();

	/*** IUnknown methods ***/
    STDMETHODIMP			QueryInterface(REFIID riid, LPVOID FAR* ppvObj) ;
    STDMETHODIMP_(ULONG)	AddRef();
    STDMETHODIMP_(ULONG)	Release();

   	/* ICustomResolver methods */
    STDMETHOD(Reconcile)(THIS_
                        IReplRowChange *pRowChange,
                        DWORD dwFlags,
                        PVOID pvReserved);

    STDMETHOD(GetHandledStates) (THIS_
    					DWORD	*pResolverBm);

private:
	ULONG				m_cRef;

	};	


#endif /* _RESOLVER_H_ */

