/******************************************************************************
* Microsoft SQLServer
*
* Microsoft Confidential.  Copyright 1993-1994 Microsoft Corporation.
*
* Component: Sample Custom Conflict Resolver
*
* File: resolver.h
*
******************************************************************************/

#ifndef _RESOLVER_H_
#define _RESOLVER_H_

#include "sqlres.h"

#define	szResolverDll					"mergetxt.dll"
#define szArticleResolver				"SOFTWARE\\Microsoft\\MSSQLServer\\Replication\\ArticleResolver"
#define szResolverDescription 			"Microsoft SQLServer Merge Text Resolver"
#define szBothThreading 				"Both"
#define szClsidMergeTextResolver 	"{6F311956-7BE4-11d1-9B0A-00C04FC2DEB3}"
static const GUID CLSID_MergeTextResolver = 
{ 0x6f311956, 0x7be4, 0x11d1, { 0x9b, 0xa, 0x0, 0xc0, 0x4f, 0xc2, 0xde, 0xb3 
} };


/* Implementation of ICustomResolver */
class CMergeTextResolver: public ICustomResolver
	{
public:
	CMergeTextResolver();
	~CMergeTextResolver();

	/*** IUnknown methods ***/
    STDMETHODIMP			QueryInterface(REFIID riid, LPVOID FAR* ppvObj) ;
    STDMETHODIMP_(ULONG)	AddRef();
    STDMETHODIMP_(ULONG)	Release();

   	/* ICustomResolver methods */
    STDMETHOD(Reconcile)(THIS_
                        IReplRowChange *pRowChange,
                        DWORD dwFlags,
                        PVOID pvReserved);

    STDMETHOD(GetHandledStates)(THIS_ DWORD *pResolverBm);

private:
	/* Instance initialization / cleanup methods */
    STDMETHOD(MergeColumn)(THIS_ IReplRowChange *pRowChange, short	Colid, LONG	Datatype);

	ULONG				m_cRef;
	LONG 				m_ReturnStatus;

	};	

class CReplicationClassFactory : public IClassFactory
{

public:
	CReplicationClassFactory(REFCLSID rclsid);
	virtual ~CReplicationClassFactory();

	/*** IUnknown methods ***/
	STDMETHOD(QueryInterface) 	(REFIID riid, LPVOID FAR* ppvObj);
	STDMETHOD_(ULONG,AddRef) 	(VOID);
	STDMETHOD_(ULONG,Release) 	(VOID);

	 /*** IClassFactory methods ***/
	STDMETHOD(CreateInstance) 		(IUnknown FAR* pUnkOuter, REFIID riid, LPVOID FAR * ppv);
	STDMETHOD(LockServer) 			(BOOL fLock);
  	STDMETHOD_(BOOL, ClassInit) 	(void);
  	STDMETHOD_(BOOL, ClassDestroy) 	(void);

private:
  	CLSID 			m_clsid;		/* Class ID */
	ULONG  			m_cRef;			/* Ref count */
}; 
/* CReplicationClassFactory */

#endif /* _RESOLVER_H_ */

