@echo off
if "%MSSQL%" == "" set MSSQL=c:\mssql7

echo Create the subscriber database
osql.exe /Usa /P /S /n /w255 /Q"exec sp_replicationdboption 'Northwind2','merge publish','false' drop database Northwind2"
osql.exe /Usa /P /S /n /w255 /Q"CREATE DATABASE Northwind2 ON (name='Northwind2dat', filename='%MSSQL%\data\Northwind2dat.dat', size=4,filegrowth=1mb) LOG ON (name='Northwind2log', filename='%MSSQL%\data\Northwind2log.dat', size=4,filegrowth=1mb)"

echo Set replication option of the publisher database
osql.exe /Usa /P /S /n /w255 /dmaster /Q"declare @ret int exec @ret = sp_replicationdboption Northwind, 'merge publish', true"

echo Install the resolver proc at the publisher database
osql.exe /Usa /P /S /n /w255 /dNorthwind /iunitpric.sql

echo Drop the existing publication
osql.exe /Usa /P /S /n /w255 /dNorthwind /Q"exec sp_dropmergesubscription 'ProductsCatalog', 'all', 'all'"
osql.exe /Usa /P /S /n /w255 /dNorthwind /Q"exec sp_dropmergepublication 'ProductsCatalog'"

echo Add a merge publication 
osql.exe /Usa /P /S /n /w255 /dNorthwind /Q"declare @ret int exec @ret = sp_addmergepublication 'ProductsCatalog'"

echo Add a merge article using the article_resolver as 'Microsoft SQLServer Publisher Stored Procedure Resolver' that calls the sp 'sp_averageunitprice'"
osql.exe /Usa /P /S /n /w255 /dNorthwind /Q"declare @ret int exec @ret = sp_addmergearticle @publication='ProductsCatalog', @article='Products Article', @source_object='Products',@article_resolver='Microsoft SQLServer Publisher Stored Procedure Resolver', @resolver_info='sp_averageunitprice'"

echo Add a merge subscription
osql.exe /Usa /P /S /n /w255 /dNorthwind /Q"declare @ret int exec @ret = sp_addmergesubscription @publication='ProductsCatalog', @subscriber=@@SERVERNAME, @subscriber_db='Northwind2', @subscription_type='push', @subscriber_type='global', @subscription_priority=0.5"

echo Run the Snapshot agent
snapshot.exe -Publisher %COMPUTERNAME% -PublisherDB Northwind -Publication ProductsCatalog -ReplicationType 2 -Distributor %COMPUTERNAME% -DistributorLogin sa -Output -OutputVerboseLevel 2 

echo Run the Merge agent
replmerg.exe  -Publisher %COMPUTERNAME% -PublisherDB Northwind -Subscriber %COMPUTERNAME% -SubscriberDB Northwind2 -SubscriberLogin sa -Distributor %COMPUTERNAME% -DistributorLogin sa -Publication ProductsCatalog -Output -OutputVerboseLevel 2 

echo Update the UnitPrice of Product ( ID = 1) to 20.0 at Publisher and 30.0 at Subscriber
osql.exe -n /Usa /P /S /dNorthwind 	/Q"update Products set UnitPrice = 20.00 where ProductID = 1"
osql.exe -n /Usa /P /S /dNorthwind2 	/Q"update Products set UnitPrice = 30.00 where ProductID = 1"

echo Run the Merge agent
replmerg.exe  -Publisher %COMPUTERNAME% -PublisherDB Northwind -Subscriber %COMPUTERNAME% -SubscriberDB Northwind2 -SubscriberLogin sa -Distributor %COMPUTERNAME% -DistributorLogin sa -Publication ProductsCatalog -Output -OutputVerboseLevel 2 

echo This query should return UnitPrice = 25.0 in the valid case)
osql.exe -n /Usa /P /S /dNorthwind 	/Q"select UnitPrice from Products where ProductID = 1"
osql.exe -n /Usa /P /S /dNorthwind2 	/Q"select UnitPrice from Products where ProductID = 1"


