/* This sp calculates the average UnitPrice and works on the Products table in northwind */
if exists (select * from sysobjects
		where type in ('P ') 
			and name = 'sp_averageunitprice')
	drop procedure sp_averageunitprice
go


create procedure sp_averageunitprice(
	@tablename 			sysname, 
	@rowguid 			uniqueidentifier, 
	@subscriber 			sysname, 
	@subscriber_db 			sysname,
	@subscriber_security_mode	int = NULL,
	@subscriber_login		sysname = NULL,
	@subscriber_password		sysname = NULL
	) 
as
	declare @subscriber_select 	nvarchar(1000)
	declare @dest_select 		nvarchar(1000)
	declare	@UnitPrice1		money
	declare @UnitPrice2		money
	declare @UnitPrice		money

	/* No heterogenous query support for now */ 
	if @subscriber <> @@servername 
		begin
		  	raiserror('Source and dest tables must be in the current server',22,127)
			return(1)
		end 
	

	/* The following resolver works on the Products table */
	if (@tablename = 'Products')
		begin

		if exists ( select name from tempdb..sysobjects where name = '##row1')
			drop table ##row1

		select @subscriber_select = 'SELECT a.*  into ##row1 FROM ' + @subscriber_db + '.dbo.Products As a where rowguidcol = ''' + convert(nchar(36), @rowguid) + ''''
		--select 'subscriber select' = @subscriber_select
		exec (@subscriber_select)

		select @UnitPrice1 = UnitPrice from ##row1

		if exists ( select name from tempdb..sysobjects where name = '##row2')
			drop table ##row2

		select @dest_select = 'SELECT a.*  into ##row2 FROM dbo.Products As a where rowguidcol = ''' + convert(nchar(36), @rowguid) + ''''		
		--select 'dest select' = @dest_select
		exec (@dest_select)

		select @UnitPrice2 = UnitPrice from ##row2

		select @UnitPrice = (@UnitPrice1 + @UnitPrice2) / 2
		update ##row1 set UnitPrice = @UnitPrice 
		select * from ##row1

		end
go

