@echo off
setlocal 
if "%1" == "?"          goto Usage

set SourceDir=WinDebug
if "%MSSQL%" == "" 	set MSSQL=c:\mssql7
if "%2" == "debug" 	set SourceDir=.\WinDebug
if "%2" == "retail" 	set SourceDir=.\WinRel

if "%1" == "x86" 	goto X86
if "%1" == "alpha" 	goto Alpha

:X86
if "%2" == "debug" 	goto DebugX86
if "%2" == "retail" 	goto RetailX86

:Alpha
if "%2" == "debug" 	goto DebugAlpha
if "%2" == "retail" 	goto RetailAlpha

nmake /f resolx86.mak CFG="Win32 Debug" clean
goto TargetDir

:DebugX86
echo "Building debug x86 binary"
nmake /f resolx86.mak CFG="Win32 Debug" %4
goto TargetDir

:RetailX86
echo "Building retail x86 binary"
nmake /f resolx86.mak CFG="Win32 Release" %4
goto TargetDir

:DebugAlpha
echo "Building debug alpha binary"
nmake /f resolaxp.mak CFG="Win32 Debug" %4
goto TargetDir

:RetailAlpha
echo "Building retail alpha binary"
nmake /f resolaxp.mak CFG="Win32 Release" %4
goto TargetDir

:TargetDir
echo "Downloading binary to target directory"
if "%3" == "" goto CopyBinn
copy %SourceDir%\subspres.dll %3
cd %3
echo "Registering binary in target directory"
regsvr32 subspres.dll
goto EndBat

:CopyBinn
copy %SourceDir%\subspres.dll %MSSQL%\binn
echo "Registering binary in %MSSQL%\binn directory"
cd %MSSQL%\binn
regsvr32 subspres.dll
goto EndBat

goto EndBat

:Usage
echo.
echo "Argument syntax: build [x86|alpha] [debug|retail] [target_dir] [clean]"
echo.

:EndBat
endlocal