@echo off
if "%MSSQL%" == "" set MSSQL=c:\mssql7

echo Create the publisher database
osql.exe /Usa /P /S /n /w255 /Q"exec sp_replicationdboption 'pubdb','merge publish','false' drop database pubdb"
osql.exe /Usa /P /S /n /w255 /Q"CREATE DATABASE pubdb ON (name='pubdbdat', filename='%MSSQL%\data\pubdbdat.dat', size=4,filegrowth=1mb) LOG ON (name='pubdblog', filename='%MSSQL%\data\pubdblog.dat', size=2,filegrowth=1mb)"

echo Create the subscriber database
osql.exe /Usa /P /S /n /w255 /Q"exec sp_replicationdboption 'subdb','merge publish','false' drop database subdb"
osql.exe /Usa /P /S /n /w255 /Q"CREATE DATABASE subdb ON (name='subdbdat', filename='%MSSQL%\data\subdbdat.dat', size=4,filegrowth=1mb) LOG ON (name='subdblog', filename='%MSSQL%\data\subdblog.dat', size=4,filegrowth=1mb)"

echo Set replication option of the publisher database
osql.exe /Usa /P /S /n /w255 /dmaster /Q"declare @ret int exec @ret = sp_replicationdboption pubdb, 'merge publish', true"

echo Create the tables that need to be published
osql.exe /Usa /P /S /n /w255 /dpubdb /isprtabl.sql

echo Create the tables that need to be published
osql.exe /Usa /P /S /n /w255 /dpubdb /isprproc.sql

echo Install the proc at the subscriber database
osql.exe /Usa /P /S /n /w255 /dsubdb /isprproc.sql

echo Insert 10 records at the publisher
osql.exe /Usa /P /S /n /w255 /dpubdb /Q"declare @ret int exec @ret = add_data 10"

echo Add a merge publication 
osql.exe /Usa /P /S /n /w255 /dpubdb /Q"declare @ret int exec @ret = sp_addmergepublication 'pub1'"

echo Add a merge article using the article_resolver as 'Microsoft SQLServer Subscriber Stored Procedure Resolver' that calls the sp 'sp_authority_resolver'"
osql.exe /Usa /P /S /n /w255 /dpubdb /Q"declare @ret int exec @ret = sp_addmergearticle @publication='pub1', @article='testdata_article', @source_object='testdata',@article_resolver='Microsoft SQLServer Subscriber Stored Procedure Resolver', @resolver_info='sp_authority_resolver'"

echo Add a merge subscription
osql.exe /Usa /P /S /n /w255 /dpubdb /Q"declare @ret int exec @ret = sp_addmergesubscription @publication='pub1', @subscriber=@@SERVERNAME, @subscriber_db='subdb', @subscription_type='push', @subscriber_type='global', @subscription_priority=0.5"

echo Run the Snapshot agent
snapshot.exe -Publisher %COMPUTERNAME% -PublisherDB pubdb -Publication pub1 -ReplicationType 2 -Distributor %COMPUTERNAME% -DistributorLogin sa -Output  

echo Run the Merge agent
replmerg.exe  -Publisher %COMPUTERNAME% -PublisherDB pubdb -Subscriber %COMPUTERNAME% -SubscriberDB subdb -SubscriberLogin sa -Distributor %COMPUTERNAME% -DistributorLogin sa -Publication pub1 -Output 

echo Insert 10 records at the subscriber
osql.exe /Usa /P /S /dsubdb /n /w255 /Q"declare @ret int exec @ret = add_data 10"

echo Run the Merge agent
replmerg.exe  -Publisher %COMPUTERNAME% -PublisherDB pubdb -Subscriber %COMPUTERNAME% -SubscriberDB subdb -SubscriberLogin sa -Distributor %COMPUTERNAME% -DistributorLogin sa -Publication pub1 -Output 

echo Update record at the publisher and subscriber with same authority (10) - Update at publisher should win
osql.exe /Usa /P /S /dsubdb /n /w255 /Q"update testdata set authority = 10, value = 'SUB updated Row#6'  where value = 'pubdb Row# 6'"
osql.exe /Usa /P /S /dpubdb /n /w255 /Q"update testdata set authority = 10, value = 'PUB updated Row#6'  where value = 'pubdb Row# 6'"

echo Update record at the publisher with authority 9 and subscriber with authority 10 - Update at subscriber should win
osql.exe /Usa /P /S /dsubdb /n /w255 /Q"update testdata set authority = 10, value = 'SUB updated Row#2'  where value = 'subdb Row# 2'"
osql.exe /Usa /P /S /dpubdb /n /w255 /Q"update testdata set authority = 9,  value = 'PUB updated Row#2'  where value = 'subdb Row# 2'"

echo Update record at the subscriber with authority 9 and publisher with authority 10 - Update at publisher should win
osql.exe /Usa /P /S /dsubdb /n /w255 /Q"update testdata set authority = 9,  value = 'SUB updated Row#9'  where value = 'subdb Row# 9'"
osql.exe /Usa /P /S /dpubdb /n /w255 /Q"update testdata set authority = 10, value = 'PUB updated Row#9'  where value = 'subdb Row# 9'"

echo Run the Merge agent
replmerg.exe  -Publisher %COMPUTERNAME% -PublisherDB pubdb -Subscriber %COMPUTERNAME% -SubscriberDB subdb -SubscriberLogin sa -Distributor %COMPUTERNAME% -DistributorLogin sa -Publication pub1 -Output 

echo Invalid data ( This query should return no data in the valid case)
osql.exe /Usa /P /S /dpubdb /n /w255 /Q"select 'guid'=p.guidcol, 'pub value'=p.value, 'pub authority'=p.authority, 'sub value'=s.value, 'sub authority'=s.authority  from pubdb..testdata p, subdb..testdata s where p.guidcol = s.guidcol and (p.value != s.value or p.authority != s.authority)"

