/******************************************************************************
* Microsoft SQLServer
*
* Microsoft Confidential.  Copyright 1993-1994 Microsoft Corporation.
*
* Component: Sample Custom Conflict Resolver
*
* File: pubspres.h
*
******************************************************************************/

#ifndef _SUBSPRES_H_
#define _SUBSPRES_H_

#include "sqlres.h"
#include "odbcconn.h"

#define	szResolverDll					"subspres.dll"
#define szArticleResolver				"SOFTWARE\\Microsoft\\MSSQLServer\\Replication\\ArticleResolver"
#define szResolverDescription 			"Microsoft SQLServer Subscriber Stored Procedure Resolver"
#define szBothThreading 				"Both"
#define szClsidStoredProcedureResolver 	"{6F31CE42-7BE4-11d1-9B0A-00C04FC2DEB3}"
static const GUID CLSID_StoredProcedureResolver = 
{ 0x6f31ce42, 0x7be4, 0x11d1, { 0x9b, 0xa, 0x0, 0xc0, 0x4f, 0xc2, 0xde, 0xb3 
} };

class CSupportErrorInfo;

/* Implementation of ICustomResolver */
class CSubSpResolver: public ICustomResolver
	{
public:
	CSubSpResolver();
	~CSubSpResolver();

	/*** IUnknown methods ***/
    STDMETHODIMP			QueryInterface(REFIID riid, LPVOID FAR* ppvObj) ;
    STDMETHODIMP_(ULONG)	AddRef();
    STDMETHODIMP_(ULONG)	Release();

   	/* ICustomResolver methods */
    STDMETHOD(Reconcile)(THIS_
                        IReplRowChange *pRowChange,
                        DWORD dwFlags,
                        PVOID pvReserved);

    STDMETHOD(GetHandledStates)(THIS_ DWORD *pResolverBm);

private:
	/* Instance initialization / cleanup methods */
    STDMETHODIMP_(BOOL)	InitInstance();
    STDMETHODIMP_(BOOL)	ExitInstance();

	ULONG				m_cRef;
	CODBCConnection		m_ReplConnection;
	LONG 				m_ReturnStatus;
	CSupportErrorInfo * m_pSupportErrorInfo;
    BOOL         		m_fInitialized;
	BOOL				m_fDestConnectionExists;
	BOOL				m_fSourceConnectionExists;
	};	


#endif /* _SUBSPRES_H_ */

