use master
go
-- Get local server name
declare @servername sysname
select @servername = srvname from master..sysservers where srvid = 0

-- Get local install path
declare @install_path varchar (255)
exec master.dbo.xp_regread 'HKEY_LOCAL_MACHINE',
	'SOFTWARE\Microsoft\MSSQLServer\Setup',
	'SQLPath',
	@param = @install_path OUTPUT

-- Adding the distributor
exec sp_adddistributor  @distributor = @servername

-- Adding the distributor database
declare @data_folder varchar(255)
set @data_folder = @install_path + '\DATA'
exec sp_adddistributiondb  @database = 'distribution', @data_folder = @data_folder, @data_file = 'distribution_Data', @data_file_size = 5, @log_folder = @data_folder, @log_file = 'distribution_Log', @log_file_size = 2, @min_distretention = 0, @max_distretention = 72, @history_retention = 48, @security_mode = 1

-- Adding the distribution publisher
declare @working_folder varchar(255)
set @working_folder = @install_path + '\REPLDATA'
exec sp_adddistpublisher  @publisher = @servername, @distribution_db = 'distribution', @security_mode = 1, @working_directory = @working_folder, @encrypted_password = 1

-- Adding the local server as a registered subscriber
exec sp_addsubscriber @subscriber = @servername, @type = 0, @login = 'sa', @security_mode = 0, @frequency_type = 64, @frequency_interval = 1, @frequency_relative_interval = 2, @frequency_recurrence_factor = 0, @frequency_subday = 8, @frequency_subday_interval = 1, @active_start_date = 0, @active_end_date = 99991231, @active_start_time_of_day = 0, @active_end_time_of_day = 235900, @status_batch_size = 100, @commit_batch_size = 100, @description = '', @encrypted_password = 1
exec sp_changesubscriber_schedule @subscriber = @servername, @agent_type = '1'

-- Create Sample Subscriber Databases
declare @dbfile varchar(255)
select @dbfile = @data_folder + '\SampSub1.mdf'
EXECUTE ('CREATE DATABASE SampleSubscriberDB1 ON PRIMARY (NAME = ''SampleSubscriberDB1'', FILENAME = ''' + @dbfile + ''')')
select @dbfile = @data_folder + '\SampSub2.mdf'
EXECUTE ('CREATE DATABASE SampleSubscriberDB2 ON PRIMARY (NAME = ''SampleSubscriberDB2'', FILENAME = ''' + @dbfile + ''')')

