Attribute VB_Name = "SampPublication"
Sub CreatePublisher()
   ' Connect to SQL Server Distributor
    Dim oSqlServer As New SQLDMO.SQLServer
    Dim strWrkDir As String
        
    oSqlServer.Connect "", "sa", ""
    On Error GoTo ErrorHandler
    
    ' Get the drive and dir info
    strWrkDir = oSqlServer.Registry.SQLRootPath
    strWrkDir = strWrkDir + "\repldata"

    ' Create Distribution Publisher
    Dim oSamplePublisher As New DistributionPublisher
    oSamplePublisher.Name = "SamplePublisher"
    oSamplePublisher.DistributionDatabase = "distribution"
    oSamplePublisher.DistributionWorkingDirectory = strWrkDir
    oSamplePublisher.ThirdParty = True
    oSqlServer.Replication.Distributor.DistributionPublishers.Add oSamplePublisher
    
    ' Create Subscribers
    Dim oRegSubscriber As New SQLDMO.RegisteredSubscriber
    oRegSubscriber.Name = oSqlServer.HostName
    oRegSubscriber.Type = SQLDMOSubInfo_SQLServer
    
    
    ' Add Subscribers
    oSamplePublisher.RegisteredSubscribers.Add oRegSubscriber
  
    oSqlServer.Close
    Exit Sub
ErrorHandler:
    PrintErrors oSqlServer
    Exit Sub

End Sub

Sub CreatePublication()
' Connect to SQL Server Distributor
    Dim oSqlServer As New SQLDMO.SQLServer
    oSqlServer.Connect "", "sa", ""
    On Error GoTo ErrorHandler

    Dim oSamplePublisher As DistributionPublisher
    Set oSamplePublisher = oSqlServer.Replication.Distributor.DistributionPublishers("SamplePublisher")
    
    ' Create Sample Publication
    Dim oSamplePublication As New DistributionPublication
    oSamplePublication.Name = "SamplePublication"
    oSamplePublication.PublicationDB = "SampleDatabase"
    oSamplePublication.PublicationType = SQLDMOPublication_Transactional
    oSamplePublication.VendorName = "Sample Vendor"
    oSamplePublication.LogReaderAgent = "SampleLogReaderAgent"
    oSamplePublication.SnapshotAgent = "SampleSnapShotAgent"
    oSamplePublication.Description = "Sample Publication Definition"
    oSamplePublication.PublicationAttributes = SQLDMOPubAttrib_AllowPush
    
    ' Add the Publication
    oSamplePublisher.DistributionPublications.Add oSamplePublication
    
    ' Create Sample Articles
    Dim oSampleArticle1 As New DistributionArticle
    oSampleArticle1.Name = "SampleArticle1"
    oSampleArticle1.Description = "Sampe Article1 Definition"
    oSampleArticle1.SourceObjectName = "SampleTable1"
    
    Dim oSampleArticle2 As New DistributionArticle
    oSampleArticle2.Name = "SampleArticle2"
    oSampleArticle2.Description = "Sample Article2 Definition"
    oSampleArticle2.SourceObjectName = "SampleTable2"
    
    ' Add the Articles to the Publication
    oSamplePublication.DistributionArticles.Add oSampleArticle2
    oSamplePublication.DistributionArticles.Add oSampleArticle1
        
    oSqlServer.Close
    Exit Sub
ErrorHandler:
    PrintErrors oSqlServer
    Exit Sub
End Sub
Sub CreatePushSubscription()
  ' Connect to SQL Server Distributor
    Dim oSqlServer As New SQLDMO.SQLServer
    oSqlServer.Connect "", "sa", ""
    On Error GoTo ErrorHandler

    Dim oSamplePublisher As DistributionPublisher
    Dim oSamplePubliction As DistributionPublication
    
    Set oSamplePublisher = oSqlServer.Replication.Distributor.DistributionPublishers("SamplePublisher")
    Set oSamplePublication = oSamplePublisher.DistributionPublications("SampleDatabase.SamplePublication")
    
    
    'Create Push Subscriptions
    Dim oPushSubscription As New DistributionSubscription
    oPushSubscription.Subscriber = oSqlServer.HostName
    oPushSubscription.SubscriptionDB = "SampleSubscriberDB1"
    oPushSubscription.SubscriptionType = SQLDMOSubscription_Push
    oPushSubscription.Status = SQLDMOSubStat_Unsynced
        
    ' Add the subscriptions to the publication
    oSamplePublication.DistributionSubscriptions.Add oPushSubscription
      
    oSqlServer.Close
    Exit Sub
ErrorHandler:
    PrintErrors oSqlServer
    Exit Sub
    
End Sub

Sub DropPullSubscription()
 ' Connect to SQL Server Distributor
    Dim oSqlServer As New SQLDMO.SQLServer
    oSqlServer.Connect "", "sa", ""
    On Error GoTo ErrorHandler

    Dim oSamplePublisher As DistributionPublisher
    Dim oSamplePubliction As DistributionPublication
    
    Set oSamplePublisher = oSqlServer.Replication.Distributor.DistributionPublishers("SamplePublisher")
    Set oSamplePublication = oSamplePublisher.DistributionPublications("SampleDatabase.SamplePublication")
    
    ' Drop Pull Subscriptions
    oSamplePublication.DistributionSubscriptions.Remove ("Subscriber2:SubscriptionDatabase")
         
    oSqlServer.Close
    Exit Sub
ErrorHandler:
    PrintErrors oSqlServer
    'Resume Next
End Sub

Sub DropPushSubscription()
' Connect to SQL Server Distributor
    Dim oSqlServer As New SQLDMO.SQLServer
    oSqlServer.Connect "", "sa", ""
    On Error GoTo ErrorHandler

    Dim oSamplePublisher As DistributionPublisher
    Dim oSamplePubliction As DistributionPublication
    
    Set oSamplePublisher = oSqlServer.Replication.Distributor.DistributionPublishers("SamplePublisher")
    Set oSamplePublication = oSamplePublisher.DistributionPublications("SampleDatabase.SamplePublication")
    
    ' Drop Pull Subscriptions
    oSamplePublication.DistributionSubscriptions.Remove (oSqlServer.HostName & ":SampleSubscriberDB1")
         
    oSqlServer.Close
    Exit Sub
ErrorHandler:
    PrintErrors oSqlServer
    'Resume Next
End Sub

Sub DropPublication()
' Connect to SQL Server Distributor
    Dim oSqlServer As New SQLDMO.SQLServer
    oSqlServer.Connect "", "sa", ""
    On Error GoTo ErrorHandler

    Dim oSamplePublisher As DistributionPublisher
     
    Set oSamplePublisher = oSqlServer.Replication.Distributor.DistributionPublishers("SamplePublisher")
       
    ' Drop Publication
    oSamplePublisher.DistributionPublications.Remove ("SampleDatabase.SamplePublication")
    oSqlServer.Close
    Exit Sub
ErrorHandler:
    PrintErrors oSqlServer
    Resume Next
End Sub

Sub DropPublisher()
' Connect to SQL Server Distributor
    Dim oSqlServer As New SQLDMO.SQLServer
    oSqlServer.Connect "", "sa", ""
    On Error GoTo ErrorHandler

    Dim oSamplePublisher As DistributionPublisher
    Dim oSamplePubliction As DistributionPublication
    
    Set oSamplePublisher = oSqlServer.Replication.Distributor.DistributionPublishers("SamplePublisher")
   
    ' Drop Subscriber
    oSamplePublisher.RegisteredSubscribers.Remove (oSqlServer.HostName)
 
    
    ' Drop Publisher
     oSqlServer.Replication.Distributor.DistributionPublishers.Remove ("SamplePublisher")

    oSqlServer.Close
    Exit Sub
ErrorHandler:
    PrintErrors oSqlServer
    'Resume Next
End Sub

Sub PrintErrors(c As Object)
    If Err.Number <> 0 Then
        e$ = Err.Source & " Error " & Err.Number - vbObjectError & ": " & Err.Description
        MsgBox e$
    End If
    
End Sub
