Attribute VB_Name = "basSQLNS"
'**********************************************************************
' sqlns - SQL Namespace Object Browser
' helper functions and structures for the SQL Namespace Object Browser.
' NOTE: This program is for demostration purposes only.
'**********************************************************************

Option Explicit

'**********************************************************************
' constants
'**********************************************************************
Public Const txtEnabled = &H80000005
Public Const txtDisabled = &H8000000F
Public Const MAX_COMPUTERNAME_LENGTH = 16

Public Const MAX_ELEMENTS = 10
Public Const ROOT_ELEMENT = 0
Public Const LAST_ELEMENT = 1

'**********************************************************************
' declare Win32 functions
'**********************************************************************
Public Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Public Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Public Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long

'**********************************************************************
' structures
'**********************************************************************
Public Type SQLNSNODE
    hItem As Long
    objSQLNamespaceObject As SQLNS.SQLNamespaceObject
    strSQLNSObjectType As String
    strParameters As String
End Type

'**********************************************************************
' GetObjectByID
'**********************************************************************
Function GetObjectByID(ObjectID As Long) As String
    Dim objSQLNameSpace As New SQLNS.SQLNamespace
    Dim t As TLI.InterfaceInfo
    Dim x As TLI.TypeLibInfo
    Dim m As TLI.Members
    Dim i As Integer
    
    On Error Resume Next
    
    Set t = InterfaceInfoFromObject(objSQLNameSpace)
    Set x = t.Parent
    Set m = x.Constants.NamedItem("SQLNSObjectType").Members
      
    For i = 1 To m.Count
        ' Debug.Print m.Item(i).Name & "-" & m.Item(i).Value
        If m.Item(i).Value = ObjectID Then
            GetObjectByID = m.Item(i).Name
            Set objSQLNameSpace = Nothing
            Exit Function
        End If
    Next
    
    ' assert if nothing valid is found
    GetObjectByID = "UNKNOWN OBJECTID"
    Debug.Assert (False)
    Set objSQLNameSpace = Nothing

End Function

'**********************************************************************
' GetCommandByID
'**********************************************************************
Function GetCommandByID(CommandID As Long) As String
    Dim objSQLNameSpace As New SQLNS.SQLNamespace
    Dim t As TLI.InterfaceInfo
    Dim x As TLI.TypeLibInfo
    Dim m As TLI.Members
    Dim i As Integer
    
    On Error Resume Next
    
    Set t = InterfaceInfoFromObject(objSQLNameSpace)
    Set x = t.Parent
    Set m = x.Constants.NamedItem("SQLNSCommandID").Members
      
    For i = 1 To m.Count
        ' Debug.Print m.Item(i).Name & "-" & m.Item(i).Value
        If m.Item(i).Value = CommandID Then
            GetCommandByID = m.Item(i).Name
            Set objSQLNameSpace = Nothing
            Exit Function
        End If
    Next
    
    ' assert if nothing valid is found
    GetCommandByID = "UNKNOWN COMMANDID"
    Debug.Assert (False)
    Set objSQLNameSpace = Nothing
    
End Function

'**********************************************************************
' GetRootTypes
'**********************************************************************
Sub GetRootTypes(lb As Control)
    
    ' initialize all root object type in listbox
    lb.Clear
    
    Dim objSQLNameSpace As New SQLNS.SQLNamespace
    Dim t As TLI.InterfaceInfo
    Dim x As TLI.TypeLibInfo
    Dim m As TLI.Members
    Dim i As Integer
    
    On Error Resume Next
    
    Set t = InterfaceInfoFromObject(objSQLNameSpace)
    Set x = t.Parent
    Set m = x.Constants.NamedItem("SQLNSRootType").Members
      
    For i = 1 To m.Count
        lb.AddItem m.Item(i).Name, m.Item(i).Value
    Next
    
    If lb.ListCount > 0 Then lb.ListIndex = 0
    
    Set objSQLNameSpace = Nothing
    
End Sub

'**********************************************************************
' GetRootTypeByID
'**********************************************************************
Function GetRootTypeByID(RootID As Long) As String
    Dim objSQLNameSpace As New SQLNS.SQLNamespace
    Dim t As TLI.InterfaceInfo
    Dim x As TLI.TypeLibInfo
    Dim m As TLI.Members
    Dim i As Integer
    
    On Error Resume Next
    
    Set t = InterfaceInfoFromObject(objSQLNameSpace)
    Set x = t.Parent
    Set m = x.Constants.NamedItem("SQLNSRootType").Members
      
    For i = 1 To m.Count
        ' Debug.Print m.Item(i).Name & "-" & m.Item(i).Value
        If m.Item(i).Value = RootID Then
            GetRootTypeByID = m.Item(i).Name
            Set objSQLNameSpace = Nothing
            Exit Function
        End If
    Next
    
    ' assert if nothing valid is found
    GetRootTypeByID = "UNKNOWN ROOTTYPE"
    Debug.Assert (False)
    Set objSQLNameSpace = Nothing

End Function

